<template>
  <section class="main-content">
    
    <breadcrumb separator="›">
      <breadcrumb-item label="Início" to="/admin"></breadcrumb-item>
    </breadcrumb>

    <nav class="nav">
      <div class="nav-left">
        <div class="nav-item">
          <h2 class="title">{{pageTitle}}</h2>
        </div>
      </div>
    </nav>

    <div class="columns">
      <div class="column is-6 is-offset-3">

        <div class="field">
          <p class="control">
            <label for="txtTitulo">Título</label>
            <input type="text" class="input" id="txtTitulo" maxlength="100" v-model="fData.title">
            <span class="is-pulled-right" style="font-size: 12px">
              <charcount
                :dataString="fData.title"
                :countdown="100"
                suffix=" caracteres restantes"
              />
            </span>
          </p>
        </div>

        <div class="field">
          <p class="control">
            <label for="txtDesc">Resumo</label>
            <textarea id="textDesc" class="textarea" maxlength="300" v-model="fData.description"></textarea>
            <span class="is-pulled-right" style="font-size: 12px">
              <charcount
                :dataString="fData.description"
                :countdown="300"
                suffix=" caracteres restantes"
              />
            </span>
          </p>
        </div>

        <div class="field">
          <p class="control">
            <label for="txtSource">Fonte</label>
            <input type="text" class="input" id="txtSource" maxlength="30" v-model="fData.source">
          </p>
        </div>

        <div class="field">
          <p class="control">
            <label for="txtInstituicao">Instituição Responsável</label>
            <input type="text" class="input" id="txtInstituicao" v-model="fData.institutionName">
          </p>
        </div>

        <div class="field">
          <p class="control">
            <label for="txtContatoNome">Nome do contato</label>
            <input type="text" class="input" id="txtContatoNome" v-model="fData.contactName">
          </p>
        </div>

        <div class="field">
          <p class="control">
            <label for="txtContatoEmail">Email do contato</label>
            <input type="email" class="input" id="txtContatoEmail" v-model="fData.contactEmail">
          </p>
        </div>

        <div class="field">
          <p class="control">
            <label for="idioma">Selecione o Idioma:</label>
            <span class="select is-fullwidth">
              <select id="idioma" class="form-control" v-model="fData.language">
                <option value="Português" selected>Português do Brasil</option>
                <option value="Inglês">English</option>
              </select>
            </span>
          </p>
        </div>

        <h3>ODS:</h3>
        
        <div class="control" v-if="$route.params.id">
          <categories-editor
            :max="3"
            :items="ods"
            :selectedItems="fData.ods"
            name="ods-iniciativa-edit"
            keylabel="title"
            keyvalue="id"
            :solutionId="$route.params.id"
          />
        </div>

        <div class="control" v-else>
          <checkbox-group
            :items="ods"
            :max="3"
            name="ods-iniciativa"
            keylabel="title"
            keyvalue="id"
            v-model="fData.ods"
          />
        </div>

        <h3>Tags:</h3>

        <p class="control" v-if="$route.params.id">
          <TagsEditor :max="2" :addedTags="tags" :solutionId="$route.params.id" />
        </p>
        <p class="control" v-else>
          <multiselect
            v-model="fData.tags"
            :options="tags"
            :close-on-select="true"
            :clear-on-select="false"
            :multiple="true"
            :hideSelected="true"
            :max="2"
            :optionsLimit="2"
            :taggable="true"
            @tag="addTag"
            @search-change="findTag"
            tagPlaceholder="Pressione enter para criar uma nova tag"
            selectLabel=""
            selectedLabel="Selecionado"
            placeholder="Selecione até 2 tags"
            id="temas-solucao"
            class="form-control"
            ref="multiselectTema">
            <span slot="noResult">Nenhum tema encontrado.</span>
            <span slot="maxElements">Máximo de 2 temas selecionados. Para adicionar outro, primeiro remova um existente</span>
          </multiselect>
        </p>

        <h3>Endereço</h3>

        <p class="control has-addons" v-if="!$route.params.id || mudarAddress">
            <GmapAutocomplete class="input" style="width: 100%" @place_changed="setPlace" />
            <button class="button is-primary" @click="usePlace">Ver no mapa e adicionar</button>
        </p>
        <p class="control has-addons" v-else>
          <input type="input" class="input" style="width: 100%" readonly v-model="fData.addressFormatted" />
          <button class="button is-primary" @click="mudarEndereco">Modificar</button>
        </p>
        <div class="control" v-if="showMap">
          <GmapMap style="width: 100%; height: 500px;" :zoom="mapZoom" :center="mapCenter">
            <GmapMarker
              :position="marker.position"
              />
            <GmapMarker
              v-if="this.place"
              label="★"
              :position="{
                lat: this.place.geometry.location.lat(),
                lng: this.place.geometry.location.lng(),
              }"
              />
          </GmapMap>
        </div>

        <div class="has-text-right">
          <button
            class="button is-primary"
            :class="{ 'is-loading': prosseguirBtnDisable, 'is-disabled': prosseguirBtnDisable }"
            :disabled="prosseguirBtnDisable || $v.fData.$invalid"
            v-if="showBtnProsseguir"
            @click="save()"
          >{{btnLabel}}</button>
        </div>

      </div>
    </div>
  </section>
</template>

<script>
  import Multiselect from 'vue-multiselect'
  import TagsEditor from './tags-editor-component.vue'
  import CheckboxGroup from './checkbox-group-component.vue'
  import CategoriesEditor from './categories-editor-component.vue'
  import { required, maxLength } from 'vuelidate/lib/validators'
  import { mapActions } from 'vuex'

  import charcount from './char-count-component.vue'

  import { getOds } from '../api/ods.service.js'
  import { findTags } from '../api/tags.service.js'
  import { getInitiative } from '../api/initiative.service.js'

  export default {
    name: 'AdicionarIniciativa',

    components: { Multiselect, charcount, TagsEditor, CheckboxGroup, CategoriesEditor },

    data () {
      return {
        pageTitle: 'Adicionar Iniciativa',
        btnLabel: 'Prosseguir',
        ods: [],
        mudarAddress: false,
        disableOds: false,
        showMap: false,
        fData: {
          title: '',
          description: '',
          source: '',
          institutionName: '',
          contactName: '',
          contactEmail: '',
          language: 'Português',
          ods: [],
          addressFormatted: '',
          addressLatitude: 0,
          addressLongitude: 0,
          addressCity: '',
          addressState: '',
          tags: []
        },
        showBtnProsseguir: true,
        tags: [],
        mapCenter: { lat: -14.235004, lng: -51.92527999999999 },
        mapZoom: 5,
        marker: {},
        place: null,
        prosseguirBtnDisable: false
      }
    },

    validations: {
      fData: {
        title: {
          required,
          maxLength: maxLength(100)
        },
        description: {
          required,
          maxLength: maxLength(300)
        },
        institutionName: {
          required
        },
        contactName: {
          required
        },
        contactEmail: {
          required
        },
        language: {
          required
        },
        ods: {
          required
        },
        tags: {
          required
        },
        addressFormatted: {
          required
        }
      }
    },

    mounted() {
      if (!this.$route.params.id) {
        navigator.geolocation.getCurrentPosition(
          (pos) => this.mapCenter = { lat: pos.coords.latitude, lng: pos.coords.longitude }
        )
      } else {
        this.pageTitle = "Editar Iniciativa"
        this.btnLabel = "Salvar"
        this.showMap = true
        getInitiative(this.$route.params.id)
          .then(
            success => {
              this.fData = {
                title: success.data.title,
                description: success.data.description,
                institutionName: success.data.institutionName,
                source: success.data.source || '',
                contactName: success.data.contactName,
                contactEmail: success.data.contactEmail,
                language: success.data.language,
                addressFormatted: success.data.addressFormatted,
                addressLatitude: success.data.addressLatitude,
                addressLongitude: success.data.addressLongitude,
                addressCity: success.data.addressCity,
                addressState: success.data.addressState,
                addressCountry: success.data.addressCountry,
                tags: [],
                ods: []
              }
              success.data.ods.map(item => {
                this.fData.ods.push(item.id)
              })
              success.data.tags.map(item => {
                this.tags.push(item)
                this.fData.tags.push(item)
              })
              this.marker = {
                position: {
                  lat: success.data.addressLatitude,
                  lng: success.data.addressLongitude
                }
              }
              this.mapZoom = 15
              this.mapCenter = { lat: success.data.addressLatitude, lng: success.data.addressLongitude }
            }
          )
      }
      getOds()
        .then(success => this.ods = success.data.items)
    },

    methods: {
      ...mapActions(['saveCurrentIniciativa', 'updateCurrentIniciativa']),

      mudarEndereco() {
        this.showMap = true
        this.mudarAddress = true
        this.marker = {}
        this.mapZoom = 5
        this.fData.addressFormatted = ""
      },
      extracAddress(addressObj) {

        if (addressObj == undefined) {
          return {
            status: "invalid address"
          };
        }

        if (addressObj.address_components == undefined) {
          return {
            status: "invalid address"
          };
        }

        let formatedAddress = {};

        for (let i = addressObj.address_components.length - 1; i >= 0; i--) {
          let addresType = addressObj.address_components[i].types.join();

          if (addresType.includes('administrative_area_level_2')){
            formatedAddress['addressCity'] = addressObj.address_components[i].short_name;
          }
            
          if (addresType.includes('administrative_area_level_1')){
            formatedAddress['addressState'] = addressObj.address_components[i].short_name;
          }
            
          if (addresType.includes('country')){
            formatedAddress['addressCountry'] = addressObj.address_components[i].long_name
          }

        }

        return formatedAddress;

      },
      getStateAndCity() {
        if (this.place) {
          let statecity = this.extracAddress(this.place);
          this.fData.addressCity = statecity.addressCity;
          this.fData.addressState = statecity.addressState;
          this.fData.addressCountry = statecity.addressCountry;
          //outros campos
          this.fData.addressFormatted = this.place.formatted_address;
          this.$v.fData.addressFormatted.$touch();
        }
      },
      setPlace(place) {
        this.place = place;
        this.mapZoom = 13;
      },
      usePlace(place) {
        if (this.place) {
          this.showMap = true
          this.mapZoom = 15
          this.marker = {
            position: {
              lat: this.place.geometry.location.lat(),
              lng: this.place.geometry.location.lng()
            }
          };
          this.fData.addressLatitude = this.place.geometry.location.lat();
          this.fData.addressLongitude = this.place.geometry.location.lng();
          this.mapCenter = {
            lat: this.place.geometry.location.lat(),
            lng: this.place.geometry.location.lng()
          }
          this.getStateAndCity();
          this.place = null;
        }
      },
      addTag(tag) {
        this.tags.push(tag)
        this.fData.tags.push(tag)
      },
      findTag(query) {
        if (query.length > 2) {
          findTags(query)
            .then(
              success => {
                let tags = []
                success.data.items.map(item => {
                  tags.push(item.text);
                })
                this.tags = tags;
              }
            )
        }
      },
      save() {
        this.prosseguirBtnDisable = true;
        if (this.$route.params.id) {
          let data = Object.assign(this.fData, {})
          delete data.ods
          delete data.tags
          this.updateCurrentIniciativa({ data, onlyStore: false, id: this.$route.params.id })
            .then(
              success => {
                this.$router.push('/admin/iniciativas')
                this.prosseguirBtnDisable = false
              },
              error => {
                this.prosseguirBtnDisable = false;
              }
            )
        } else {
          this.saveCurrentIniciativa({ data: this.fData, onlyStore: false })
            .then(
              success => {
                this.prosseguirBtnDisable = false;
                this.$router.push(`/admin/iniciativa/${success.data.id}/perguntas`)
              },
              error => {
                this.prosseguirBtnDisable = false;
              }
            );
        }
      }
    },

    watch: {
      tags: function(value) {
        if (this.$route.params.id) {
          this.fData.tags = value
        }
      }
    }
  }
</script>
